.../ftrace/test.d/ftrace/fgraph-profiler.tc | 31 +++++++++++++++++++ 1 file changed, 31 insertions(+) create mode 100644 tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc
From: Steven Rostedt <rostedt@goodmis.org>
Masami reported a bug when running function graph tracing then the
function profiler. The following commands would cause a kernel crash:
# cd /sys/kernel/tracing/
# echo function_graph > current_tracer
# echo 1 > function_profile_enabled
In that order. Create a test to test this two to make sure this does not
come back as a regression.
Link: https://lore.kernel.org/172398528350.293426.8347220120333730248.stgit@devnote2
Signed-off-by: Steven Rostedt (Google) <rostedt@goodmis.org>
---
Changes since v1: https://lore.kernel.org/20240821150903.05c6cf96@gandalf.local.home
- Added comment to why we are doing a sleep 1
- Now that the fix is in mainline, we can add this to the selftests
.../ftrace/test.d/ftrace/fgraph-profiler.tc | 31 +++++++++++++++++++
1 file changed, 31 insertions(+)
create mode 100644 tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc
diff --git a/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc b/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc
new file mode 100644
index 000000000000..1580e4ef9739
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc
@@ -0,0 +1,31 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: ftrace - function profiler with function graph tracing
+# requires: function_profile_enabled set_ftrace_filter function_graph:tracer
+
+# The function graph tracer can now be run along side of the function
+# profiler. But there was a bug that caused the combination of the two
+# to crash. It also required the function graph tracer to be started
+# first.
+#
+# This test triggers that bug
+#
+# We need function_graph and profiling to to run this test
+
+fail() { # mesg
+ echo $1
+ exit_fail
+}
+
+echo "Enabling function graph tracer:"
+echo function_graph > current_tracer
+echo "enable profiler"
+
+# Older kernels do not allow function_profile to be enabled with
+# function graph tracer. If the below fails, mark it as unsupported
+echo 1 > function_profile_enabled || exit_unsupported
+
+# Let it run for a bit to make sure nothing explodes
+sleep 1
+
+exit 0
--
2.45.2
On 10/4/24 12:56, Steven Rostedt wrote: > From: Steven Rostedt <rostedt@goodmis.org> > > Masami reported a bug when running function graph tracing then the > function profiler. The following commands would cause a kernel crash: > > # cd /sys/kernel/tracing/ > # echo function_graph > current_tracer > # echo 1 > function_profile_enabled > > In that order. Create a test to test this two to make sure this does not > come back as a regression. > > Link: https://lore.kernel.org/172398528350.293426.8347220120333730248.stgit@devnote2 > > Signed-off-by: Steven Rostedt (Google) <rostedt@goodmis.org> > --- > Changes since v1: https://lore.kernel.org/20240821150903.05c6cf96@gandalf.local.home > > - Added comment to why we are doing a sleep 1 > > - Now that the fix is in mainline, we can add this to the selftests > > .../ftrace/test.d/ftrace/fgraph-profiler.tc | 31 +++++++++++++++++++ > 1 file changed, 31 insertions(+) > create mode 100644 tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc > > diff --git a/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc b/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc > new file mode 100644 > index 000000000000..1580e4ef9739 > --- /dev/null > +++ b/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc > @@ -0,0 +1,31 @@ > +#!/bin/sh > +# SPDX-License-Identifier: GPL-2.0 > +# description: ftrace - function profiler with function graph tracing > +# requires: function_profile_enabled set_ftrace_filter function_graph:tracer > + > +# The function graph tracer can now be run along side of the function > +# profiler. But there was a bug that caused the combination of the two > +# to crash. It also required the function graph tracer to be started > +# first. > +# > +# This test triggers that bug > +# > +# We need function_graph and profiling to to run this test "to to" -< "to" I noticed this during my commit checks. Please fix and send v3. > + > +fail() { # mesg > + echo $1 > + exit_fail > +} > + > +echo "Enabling function graph tracer:" > +echo function_graph > current_tracer > +echo "enable profiler" > + > +# Older kernels do not allow function_profile to be enabled with > +# function graph tracer. If the below fails, mark it as unsupported > +echo 1 > function_profile_enabled || exit_unsupported > + > +# Let it run for a bit to make sure nothing explodes > +sleep 1 > + > +exit 0
On Fri, 4 Oct 2024 14:56:18 -0400 Steven Rostedt <rostedt@goodmis.org> wrote: > From: Steven Rostedt <rostedt@goodmis.org> > > Masami reported a bug when running function graph tracing then the > function profiler. The following commands would cause a kernel crash: > > # cd /sys/kernel/tracing/ > # echo function_graph > current_tracer > # echo 1 > function_profile_enabled > > In that order. Create a test to test this two to make sure this does not > come back as a regression. > > Link: https://lore.kernel.org/172398528350.293426.8347220120333730248.stgit@devnote2 > Looks good to me. Acked-by: Masami Hiramatsu (Google) <mhiramat@kernel.org> Thanks! > Signed-off-by: Steven Rostedt (Google) <rostedt@goodmis.org> > --- > Changes since v1: https://lore.kernel.org/20240821150903.05c6cf96@gandalf.local.home > > - Added comment to why we are doing a sleep 1 > > - Now that the fix is in mainline, we can add this to the selftests > > .../ftrace/test.d/ftrace/fgraph-profiler.tc | 31 +++++++++++++++++++ > 1 file changed, 31 insertions(+) > create mode 100644 tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc > > diff --git a/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc b/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc > new file mode 100644 > index 000000000000..1580e4ef9739 > --- /dev/null > +++ b/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-profiler.tc > @@ -0,0 +1,31 @@ > +#!/bin/sh > +# SPDX-License-Identifier: GPL-2.0 > +# description: ftrace - function profiler with function graph tracing > +# requires: function_profile_enabled set_ftrace_filter function_graph:tracer > + > +# The function graph tracer can now be run along side of the function > +# profiler. But there was a bug that caused the combination of the two > +# to crash. It also required the function graph tracer to be started > +# first. > +# > +# This test triggers that bug > +# > +# We need function_graph and profiling to to run this test > + > +fail() { # mesg > + echo $1 > + exit_fail > +} > + > +echo "Enabling function graph tracer:" > +echo function_graph > current_tracer > +echo "enable profiler" > + > +# Older kernels do not allow function_profile to be enabled with > +# function graph tracer. If the below fails, mark it as unsupported > +echo 1 > function_profile_enabled || exit_unsupported > + > +# Let it run for a bit to make sure nothing explodes > +sleep 1 > + > +exit 0 > -- > 2.45.2 > -- Masami Hiramatsu (Google) <mhiramat@kernel.org>
On 10/7/24 18:33, Masami Hiramatsu (Google) wrote: > On Fri, 4 Oct 2024 14:56:18 -0400 > Steven Rostedt <rostedt@goodmis.org> wrote: > >> From: Steven Rostedt <rostedt@goodmis.org> >> >> Masami reported a bug when running function graph tracing then the >> function profiler. The following commands would cause a kernel crash: >> >> # cd /sys/kernel/tracing/ >> # echo function_graph > current_tracer >> # echo 1 > function_profile_enabled >> >> In that order. Create a test to test this two to make sure this does not >> come back as a regression. >> >> Link: https://lore.kernel.org/172398528350.293426.8347220120333730248.stgit@devnote2 >> > > Looks good to me. > > Acked-by: Masami Hiramatsu (Google) <mhiramat@kernel.org> > > Thanks! > >> Signed-off-by: Steven Rostedt (Google) <rostedt@goodmis.org> Steve, Would you like me take this one through my tree? thanks, -- Shuah
On Thu, 10 Oct 2024 11:04:43 -0600 Shuah Khan <skhan@linuxfoundation.org> wrote: > On 10/7/24 18:33, Masami Hiramatsu (Google) wrote: > > On Fri, 4 Oct 2024 14:56:18 -0400 > > Steven Rostedt <rostedt@goodmis.org> wrote: > > > >> From: Steven Rostedt <rostedt@goodmis.org> > >> > >> Masami reported a bug when running function graph tracing then the > >> function profiler. The following commands would cause a kernel crash: > >> > >> # cd /sys/kernel/tracing/ > >> # echo function_graph > current_tracer > >> # echo 1 > function_profile_enabled > >> > >> In that order. Create a test to test this two to make sure this does not > >> come back as a regression. > >> > >> Link: https://lore.kernel.org/172398528350.293426.8347220120333730248.stgit@devnote2 > >> > > > > Looks good to me. > > > > Acked-by: Masami Hiramatsu (Google) <mhiramat@kernel.org> > > > > Thanks! > > > >> Signed-off-by: Steven Rostedt (Google) <rostedt@goodmis.org> > > Steve, Would you like me take this one through my tree? > Yes please. Thanks Shuah! -- Steve
© 2016 - 2024 Red Hat, Inc.